<?php

declare(strict_types=1);

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 * @ORM\Table(name="log_event_type")
 */
class EventType
{

    public const START = 'Start';
    public const CRITICAL_ERROR_DAEMON = 'Critical error (daemon)';
    public const SHUTTING_DOWN = 'Shutting down';
    public const NEW_DEVICE_CONNECTED = 'New device connected';
    public const NEW_FW_AVAILABLE = 'New FW available';
    public const USER_DEFINED_ALERT = 'User-defined alert';
    public const GENERAL_NOTICE = 'General notice';
    public const LICENSING_ISSUE = 'Licensing issue';
    public const PERFORMING_UPGRADE = 'Performing upgrade';
    public const EVENTSYNC_DAEMON = 'Eventsync (daemon)';
    public const DEVICE_AUTOPROFILE_UPDATE = 'Device autoprofile update';
    public const TUNNEL_STATUS_UPDATE = 'Tunnel status update';
    public const DAEMON_SPECIFIC_EVENT_1 = 'Daemon specific event 1';
    public const USER_LOGIN = 'User login';
    public const CRITICAL_ERROR_WEBUI = 'Critical error (WebUI)';
    public const RESTART_REQUESTED = 'Restart requested';
    public const DEVICE_CFG_USER_UPDATE = 'Device CFG user-update';
    public const NEW_FW_VERSION_REQUESTED = 'New FW version requested';
    public const ALERT_CONFIG_UPDATE = 'Alert config update';
    public const LICENSE_UPLOADED = 'License uploaded';
    public const UPGRADE_PKG_UPLOADED = 'Upgrade pkg uploaded';
    public const EVENTSYNC_UI = 'Eventsync (UI)';
    public const PROFILE_UPDATE = 'Profile update';
    public const TUNNEL_CFG_UPDATE = 'Tunnel CFG update';
    public const MONITORING_GROUP_UPDATE = 'Monitoring group update';
    public const CFG_GROUP_UPDATE = 'CFG group update';

    /**
     * @var int|null
     * @ORM\Column(type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private ?int $id = null;

    /**
     * @var string
     * @ORM\Column(type="string", length=32, nullable=false, unique=true)
     */
    public string $name;

    /**
     * @var Collection
     * @ORM\OneToMany (targetEntity="EventLog", mappedBy="eventType", cascade={"persist"})
     * @ORM\JoinColumn(name="id")
     */
    public Collection $events;

    /**
     * EventType constructor
     */
    public function __construct() {

        $this->events = new ArrayCollection();

    }

    /**
     * @return int|null
     */
    public function getId(): ?int
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getName(): string{

        return $this->name;

    }

}