<?php

declare(strict_types=1);

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 * @ORM\Table(name="tunnel_op_status_map")
 */
class TunnelOperationStatusMapping
{
    /**
     * @var int|null
     * @ORM\Column(type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private ?int $id = null;

    /**
     * @var TunnelOperation
     * @ORM\ManyToOne(targetEntity="App\Entity\TunnelOperation", inversedBy="operationStatusMapping")
     * @ORM\JoinColumn(name="operation_id", referencedColumnName="id")
     */
    public TunnelOperation $operation;

    /**
     * @var TunnelStatus
     * @ORM\ManyToOne(targetEntity="App\Entity\TunnelStatus", inversedBy="operationStatusMapping")
     * @ORM\JoinColumn(name="status_id", referencedColumnName="id")
     */
    public TunnelStatus $status;

    /**
     * @return int|null
     */
    public function getId(): ?int {

        return $this->id;

    }

    /**
     * @return TunnelOperation
     */
    public function getOperation(): TunnelOperation {

        return $this->operation;

    }

    /**
     * @return TunnelStatus
     */
    public function getStatus(): TunnelStatus {

        return $this->status;

    }

}